library RexxUni;

{$CDecl+,OrgName+,I-,S-,Delphi+,Use32+}

Uses OS2Base, OS2Def, Rexx;

{$LINKER
  DESCRIPTION	"REXXUNI 1.0 - UNICODE API for REXX (c) 2001 by Max Alekseyev"
  DATA MULTIPLE NONSHARED

  EXPORTS
    UNIQUERYCP	  = UniQueryCp
    UNIXLAT	  = UniXlat
    UNILOADFUNCS  = UniLoadFuncs
    UNIDROPFUNCS  = UniDropFuncs
}

function UniMapCpToUcsCp(ulCodePage:ulong;var ucsCodePage;size:ulong):ulong; external 'UCONV' name 'UniMapCpToUcsCp';
function UniCreateUconvObject(var cpname, UconvObject):ulong; external 'UCONV' name 'UniCreateUconvObject';
function UniUconvFromUcs(UconvObject:pointer;var src, ssize, dst, dsize, n):ulong; external 'UCONV' name 'UniUconvFromUcs';
function UniUconvToUcs(UconvObject:pointer;var src, ssize, dst, dsize, n):ulong; external 'UCONV' name 'UniUconvToUcs';
function UniFreeUconvObject(UconvObject:pointer):ulong; external 'UCONV' name 'UniFreeUconvObject';

Const
  FunctionTable : Array[1..4] of pChar
		= ('UniQueryCp','UniXlat','UniLoadFuncs','UniDropFuncs');

type UniChar=SmallWord;

var p,d,j,t,Code:word;
    s:string;

Function UniLoadFuncs ( FuncName  : PChar;
			ArgC	  : ULong;
			Args	  : pRxString;
			QueueName : pChar;
			Var Ret   : RxString ) : ULong; export;
begin
  Ret.strLength := 0; UniLoadFuncs := 40;
  If ArgC = 0 then		     { Do not allow parameters }
  begin
    For j := Low(FunctionTable) to High(FunctionTable) do
	RexxRegisterFunctionDLL(FunctionTable[j], 'REXXUNI', FunctionTable[j]);
    UniLoadFuncs := 0;
  end;
end;

Function UniDropFuncs ( FuncName  : PChar;
			ArgC	  : ULong;
			Args	  : pRxString;
			QueueName : pChar;
			Var Ret   : RxString ) : ULong; export;
begin
  Ret.strLength := 0; UniDropFuncs := 40;
  If ArgC = 0 then		    { Do not allow parameters }
  begin
    For j := Low(FunctionTable) to High(FunctionTable) do
	RexxDeregisterFunction(FunctionTable[j]);
    UniDropFuncs := 0;
  end;
end;

function SystemCp:ULong;
var ArCP,PcCP:longint;
begin
  DosQueryCp(4,ArCP,PcCP);
  SystemCp := ArCP;
end;

function UniQueryCp( FuncName  : PChar;
		  ArgC	    : ULong;
		  Args	    : pRxString;
		  QueueName : pChar;
		  Var Ret   : RxString ) : ULong; export;
var s:string;
begin
  Ret.strLength:=0; UniQueryCp := 40;
  if ArgC=0 Then
  begin
    str(SystemCp,s);
    Ret.strLength := length(s);
    Move(s[1],Ret.strptr^,length(s));
    UniQueryCp := 0;
  end;
end;

function UniXlat(  FuncName  : PChar;
		  ArgC	    : ULong;
		  Args	    : pRxString;
		  QueueName : pChar;
		  Var Ret   : RxString ) : ULong; export;
var unistr:array[byte] of UniChar;
    cp1, cp2, Code, u : longint;
    convobj, p, q, r : pointer;
type pbyte = ^byte;
begin
  Ret.strLength:=0; UniXlat := 40;
  if (ArgC<2) or (ArgC>3) Then Exit;

    Inc(Args);
    with Args^ do if strLength=0 Then cp1:=SystemCp else
    begin
      Val(strptr,cp1,Code);
      If Code<>0 Then Exit;
    end;

    Inc(Args);
    with Args^ do if (ArgC<3) or (strLength=0) Then cp2:=SystemCp else
    begin
      Val(strptr,cp2,Code);
      If Code<>0 Then Exit;
    end;
    Dec(Args);
    Dec(Args);

    if cp2<>0 Then
    begin
      if (UniMapCpToUcsCp(cp2, unistr, 256) <> 0) or (UniCreateUconvObject(unistr,convobj) <> 0) then Exit;
      u := Args^.strLength shl 1;
      GetMem(r,u); p:=r;
      Code := UniUconvToUcs(convobj,Args^.strptr,Args^.strLength,p,u,Code);
      UniFreeUconvObject(convobj);
    end else
    begin
      r := Args^.strptr;
      u := Args^.strLength shr 1;
      Code := 0;
    end;

    if (Code=0) Then
      if(cp1<>0) Then
      begin
	Code := UniMapCpToUcsCp(cp1, unistr, 256) or UniCreateUconvObject(unistr,convobj);
	if Code = 0 Then
	begin
	  p:=r;
	  q := Ret.strptr;
	  Ret.strLength := u shl 1;			       // BUG in UniUconvFromUcs()
	  Code := UniUconvFromUcs(convobj,p,u,q,Ret.strLength,Code);
	  UniFreeUconvObject(convobj);
	end;
      end else
      with Ret do
      begin
	strLength := u shl 1;
	move(r^,strptr^,strLength);
//	Code := 0;
      end;

      if Code=0 Then UniXlat := 0;
      if cp2<>0 Then FreeMem(r);

end;

initialization
end.
